#! /usr/bin/env python


import optparse, re
from optparse import OptionParser

def __main__():
	#Parse Command Line
	parser = optparse.OptionParser()
	parser.add_option("-i", "--input", dest="inputFile", help="input gff file.")
	parser.add_option("-o", "--output", dest="outputFile", help="Out csv file.")
	(options, args) = parser.parse_args()
	fh = open(options.inputFile, "r")
	oh = open(options.outputFile, "w")
	for line in fh.readlines():
		if line.split("\t")[2] == "transcript": 
			overlap = re.search("nbOverlaps=(\d+);", line).group(1)	
			geneID = re.search("gene_id=(.*);.*=", line).group(1)
			oh.write("%s\t%s\n" % (geneID, overlap))

	fh.close()
	oh.close()

if __name__=="__main__":__main__()
