LABEL = "SSRtrf"

class SSRCollection(object):

    def __init__(self, coverage = ""):
        self._coverage = coverage
        self._lSSR = []
        
    def __eq__(self, o):
        return self._coverage == o._coverage and self._lSSR == o._lSSR
    
    #TODO: review with SuperAgent (OutputWriter)
    def __str__(self):
        if self._lSSR == []:
            return ""
        str = "%s: %s" % (LABEL, self._lSSR[0])
        for iSSR in self._lSSR[:1]:
            str += ", %s" % iSSR
        return str
    
    def strCoverage(self):
        return "SSRCoverage: %.2f%s" % (float(self._coverage)*100, '%')
    ############################################
        
    def append(self, iSSR):
        self._lSSR.append(iSSR)
        
    def setCoverage(self, coverage):
        self._coverage = coverage
        
    def isEmpty(self):
        return self._lSSR == []
    
    def getSSRList(self):
        return self._lSSR
    
    def getSSRCoverage(self):
        return self._coverage