from pyRepet.coord.RangeFeature import RangeFeature
from pyRepet.sql.TableAdaptator import TableAdaptator
from pyRepet.sql.TableAdaptator import TableSetAdaptator

class TableGFF3Adaptator(TableAdaptator):
	def __init__(self,db,tree_table_name,tree_id,tree_parent,tree_type,tree_name,tree_ref,tree_strand,tree_start,tree_end,set_table_name,set_parent,set_name,set_ref,set_start,set_end,set_feature_type):
		TableAdaptator.__init__(self,db,tree_table_name)
		self.db=db
		self.tree_table_name=tree_table_name
		self.table_set_adaptator=TableSetAdaptator(db,set_table_name)
		self.field_name_tree_id=tree_id
		self.field_name_tree_parent=tree_parent
		self.field_name_tree_type=tree_type
		self.field_name_tree_name=tree_name
		self.field_name_tree_ref=tree_ref
		self.field_name_tree_strand=tree_strand
		self.field_name_tree_start=tree_start
		self.field_name_tree_end=tree_end
		self.field_name_set_parent=set_parent
		self.field_name_set_name=set_name
		self.field_name_set_ref=set_ref
		self.field_name_set_start=set_start
		self.field_name_set_end=set_end
		self.set_feature_type=set_feature_type

	def insAGffTreeLine(self,id,parent,type,name,ref,strand,start,end):
		self.db.execute("INSERT INTO `%s` (`%s`,`%s`,`%s`,`%s`,`%s`,`%s`,`%s`,`%s`) VALUES('%s','%s','%s','%s','%s','%s','%s','%s');"%(self.tree_table_name,self.field_name_tree_id,self.field_name_tree_parent,self.field_name_tree_type,self.field_name_tree_name,self.field_name_tree_ref,self.field_name_tree_strand,self.field_name_tree_start,self.field_name_tree_end,id,parent,type,name,ref,strand,start,end))

	def insAGffSetLine(self,parent,name,ref,strand,start,end):
		self.table_set_adaptator.db.execute("INSERT INTO `%s` (`%s`,`%s`,`%s`,`%s`,`%s`) VALUES('%s','%s','%s','%s','%s');"%(self.table_set_adaptator.tablename,self.field_name_set_parent,self.field_name_set_name,self.field_name_set_ref,self.field_name_set_start,self.field_name_set_end,parent,name,ref,start,end))

	def getNewId(self):
		sql_cmd="SELECT MAX(%s) FROM %s;"%(self.field_name_set_parent,self.tree_table_name)
		self.db.execute(sql_cmd)
		max_id=self.db.fetchall()[0][0]
		if max_id==None:
			max_id=0
		return int(max_id)+1

	def getRangeFeature_from_num(self,id,table_sofa_adaptator):
		sql_cmd="SELECT `%s`,`%s`,`%s`,`%s`,`%s`,`%s` FROM %s WHERE `%s`='%i';"%(self.field_name_tree_parent,self.field_name_tree_type,self.field_name_tree_name,self.field_name_tree_ref,self.field_name_tree_start,self.field_name_tree_end,self.tree_table_name,self.field_name_tree_id,id)
		self.db.execute(sql_cmd)
		rangefeature_info=self.db.fetchall()
		set_list=self.table_set_adaptator.getSetList_from_num(id)
		rangefeature=RangeFeature(set_list=set_list,id=id,parent=rangefeature_info[0][0],type=table_sofa_adaptator.getSofaName(rangefeature_info[0][1]),name=rangefeature_info[0][2],seqname=rangefeature_info[0][3],start=rangefeature_info[0][4],end=rangefeature_info[0][5])
		sql_cmd="SELECT `%s` FROM %s WHERE `%s`='%i' ORDER BY `%s`;"%(self.field_name_tree_id,self.tree_table_name,self.field_name_tree_parent,rangefeature.id,self.field_name_tree_start)
		self.db.execute(sql_cmd)
		sons=self.db.fetchall()
		for son in sons:
			rangefeature.sub_rangefeatures.append(self.getRangeFeature_from_num(son[0],table_sofa_adaptator))
		return rangefeature
