import pyRepet.coord.RangeFeature
from pyRepet.sql.TableAdaptator import TableAdaptator

class TableSofaAdaptator(TableAdaptator):
	def __init__(self,db,sofa_table_name,sofa_id,sofa_name,sofa_def):
		TableAdaptator.__init__(self,db,sofa_table_name)
		self.field_name_sofa_id=sofa_id
		self.field_name_sofa_name=sofa_name
		self.field_name_sofa_def=sofa_def
		self.dict_sofaid={}
		self.dict_sofaname={}

	def getSofaId(self,sofa_name):
		"""
		Return
		"""
		try:
			return self.dict_sofaid[sofa_name]
		except KeyError:
			sql_cmd="SELECT %s FROM %s WHERE %s='%s';"%(self.field_name_sofa_id,self.tablename,self.field_name_sofa_name,sofa_name)
			self.db.execute(sql_cmd)
			res=self.db.fetchall()
			if res!=():
				self.dict_sofaid[sofa_name]=res[0][0]
				return res[0][0]
			else:
				print 'ERROR : Feature doesn\'t exist in SOFA'

	def getSofaName(self,sofa_id):
		"""
		Return
		"""
		try:
			return self.dict_sofaname[sofa_id]
		except KeyError:
			sql_cmd="SELECT %s FROM %s WHERE %s='%s';"%(self.field_name_sofa_name,self.tablename,self.field_name_sofa_id,sofa_id)
			self.db.execute(sql_cmd)
			res=self.db.fetchall()
			if res!=():
				self.dict_sofaname[sofa_id]=res[0][0]
				return res[0][0]
			else:
				print 'ERROR : Feature doesn\'t exist in SOFA'

	def insSofaLine(self,tid,tname,tdef):
		self.db.execute("INSERT INTO `%s` (`%s`,`%s`,`%s`) VALUES('%i','%s','%s')"%(self.tablename,self.field_name_sofa_id,self.field_name_sofa_name,self.field_name_sofa_def,tid,tname,tdef.replace('\'','\'\'')))
